import gzip
import uuid_lib

from google.appengine.ext import db
from xml.dom import minidom

def AppError(Exception):
  pass

def Upload(xml, upload_id):
  PUT_STEP = 50
  results, errors, warnings = uuid_lib.ParseXMLFile(xml, upload_id)
  if len(errors) > 0:
    raise AppError("Error parsing XML: " + ", ".join(errors));
  if len(warnings) > 0:
    raise AppError("Warnings parsing XML: " + ", ".join(warnings));

  base = 0
  while base < len(results):
    print "Storing [%d;%d) out of %d" % (base, base+PUT_STEP, len(results))
    db.put(results[base:base+PUT_STEP])
    base += PUT_STEP

def Wipe():
  count = 1
  while count > 0:
    q = db.GqlQuery("SELECT __key__ FROM UuidEntry LIMIT 200")
    results = q.fetch(200)
    db.delete(results)    
    count = len(results)
    print "Removed %d entries" % len(results);

def WipeUpload(upload_id):
  count = 1
  while count > 0:
    q = db.GqlQuery("SELECT __key__ FROM UuidEntry "
                    "WHERE upload_id = :1 LIMIT 200",
		    upload_id)
    results = q.fetch(200)
    db.delete(results)    
    count = len(results)
    print "Removed %d entries" % len(results);

def GetXml(base_dir, filename):
  raw = gzip.GzipFile('', 'r', None, open(base_dir + filename))
  xml = minidom.parse(raw)
  return xml

def UploadAll(base_dir):
  for upload_batch in uuid_lib.uploads_map.itervalues():
    if not upload_batch.uploaded:
      xml = GetXml(base_dir, upload_batch.input_name)
      Upload(xml, upload_batch.upload_id)
      print ("===> Finished uploading %s. Set uploaded to True in uuid_lib."
             % upload_batch.input_name)
