"""Handler to execute administrative tasks remotely.

Note that ungzipping the largest data file takes longer than the timeout what
makes this useful only on when testing on local machine and is disabled on
appspot.com.
"""

import cgi
import gzip
import wsgiref.handlers

import uuid_lib

from xml.dom import minidom

from google.appengine.ext import db
from google.appengine.ext import webapp

class AdminWipe(webapp.RequestHandler):
  def get(self):
    q = db.GqlQuery("SELECT * FROM UuidEntry LIMIT 200")
    results = q.fetch(200)
    for result in results:
      result.delete()
    self.response.out.write("<html>\n");
    if len(results) > 0:
      self.response.out.write('  <meta http-equiv="refresh" content="1">\n');
    self.response.out.write("  Removed %d entries\n</html>" % len(results));

class Upload(webapp.RequestHandler):
  UPLOADS = [ 1, 2 ]

  def get(self):
    PUT_STEP = 1000
    base = int(self.request.get('base', 0))
    file = int(self.request.get('file', 0))
    upload_batch = uuid_lib.uploads_map[self.UPLOADS[file]]
    raw = gzip.GzipFile('', 'r', None, open(upload_batch.input_name))
    xml = minidom.parse(raw)
    results, errors, warnings = uuid_lib.ParseXMLFile(xml,
                                                      upload_batch.upload_id)
    if len(errors) > 0:
      self.response.out.write("<html>Invalid file:<ul>")
      for error in errors:
        self.response.out.write("<li>" + error)        
      self.response.out.write("</ul></html>")
      return

    db.put(results[base:base+PUT_STEP])    
    if base + PUT_STEP < len(results):
      next_base = base + PUT_STEP
      next_file = file
    else:
      next_base = 0;
      next_file = file + 1
      
    self.response.out.write("<html>")
    self.response.out.write("<meta http-equiv=\"refresh\" " +
      "content=\"1;upload.html?base=%d&file=%d\">" % (next_base, next_file))
    self.response.out.write("Wrote rows [%d; %d) of %s (%d rows) to datastore" % (
      base, min(base+PUT_STEP, len(results)), upload_batch.input_name, len(results)))
    self.response.out.write("</html>");
     

application = webapp.WSGIApplication([
  ('/uuid/admin/index.html', AdminPanel),
  ('/uuid/admin/wipe.html', AdminWipe)
], debug=True)


def main():
  wsgiref.handlers.CGIHandler().run(application)


if __name__ == '__main__':
  main()

